libcamera: libcamera::CameraSensor Class Reference

libcamera v0.3.2 Supporting cameras in Linux since 2019

Loading...
Searching...
No Matches
Public Member Functions | Protected Member Functions | List of all members
libcamera::CameraSensor Class Reference

A camera sensor based on V4L2 subdevices. More...

Inheritance diagram for libcamera::CameraSensor:
[legend]
Collaboration diagram for libcamera::CameraSensor:
[legend]

## Public Member Functions
| CameraSensor (const MediaEntity *entity)
| Construct a CameraSensor.
| ~CameraSensor ()
| Destroy a CameraSensor.
int | init ()
| Initialize the camera sensor instance.
const std::string & | model () const
| Retrieve the sensor model name.
const std::string & | id () const
| Retrieve the sensor ID.
const MediaEntity * | entity () const
| Retrieve the sensor media entity.
V4L2Subdevice * | device ()
| Retrieve the camera sensor device.
CameraLens * | focusLens ()
| Retrieve the focus lens controller.
const std::vector< unsigned int > & | mbusCodes () const
| Retrieve the media bus codes supported by the camera sensor.
std::vector< Size > | sizes (unsigned int mbusCode) const
| Retrieve the supported frame sizes for a media bus code.
Size | resolution () const
| Retrieve the camera sensor resolution.
V4L2SubdeviceFormat | getFormat (const std::vector< unsigned int > &mbusCodes, const Size &size) const
| Retrieve the best sensor format for a desired output.
int | setFormat (V4L2SubdeviceFormat *format, Transform transform=Transform::Identity)
| Set the sensor output format.
int | tryFormat (V4L2SubdeviceFormat *format) const
| Try the sensor output format.
int | applyConfiguration (const SensorConfiguration &config, Transform transform=Transform::Identity, V4L2SubdeviceFormat *sensorFormat=nullptr)
| Apply a sensor configuration to the camera sensor.
const ControlList & | properties () const
| Retrieve the camera sensor properties.
int | sensorInfo (IPACameraSensorInfo *info) const
| Assemble and return the camera sensor info.
Transform | computeTransform (Orientation *orientation) const
| Compute the Transform that gives the requested orientation.
BayerFormat::Order | bayerOrder (Transform t) const
| Compute the Bayer order that results from the given Transform.
const ControlInfoMap & | controls () const
| Retrieve the supported V4L2 controls and their information.
ControlList | getControls (const std::vector< uint32_t > &ids)
| Read V4L2 controls from the sensor.
int | setControls (ControlList *ctrls)
| Write V4L2 controls to the sensor.
const std::vector< controls::draft::TestPatternModeEnum > & | testPatternModes () const
| Retrieve all the supported test pattern modes of the camera sensor The test pattern mode values correspond to the controls::TestPattern control.
int | setTestPatternMode (controls::draft::TestPatternModeEnum mode)
| Set the test pattern mode for the camera sensor.

## Protected Member Functions
std::string | logPrefix () const override
| Retrieve a string to be prefixed to the log message.
Protected Member Functions inherited from libcamera::Loggable
LogMessage | _log (const LogCategory *category, LogSeverity severity, const char *fileName=__builtin_FILE(), unsigned int line=__builtin_LINE()) const
| Create a temporary LogMessage object to log a message.

## Detailed Description

A camera sensor based on V4L2 subdevices.

The CameraSensor class eases handling of sensors for pipeline handlers by hiding the details of the V4L2 subdevice kernel API and caching sensor information.

The implementation is currently limited to sensors that expose a single V4L2 subdevice with a single pad. It will be extended to support more complex devices as the needs arise.

## Constructor & Destructor Documentation

## ◆ CameraSensor()

libcamera::CameraSensor::CameraSensor | ( | const MediaEntity * | entity | ) |
| explicit

Construct a CameraSensor.

Parameters

  [in] | entity | The media entity backing the camera sensor

Once constructed the instance must be initialized with init().

## Member Function Documentation

## ◆ applyConfiguration()

int libcamera::CameraSensor::applyConfiguration | ( | const SensorConfiguration & | config,
|  | Transform | transform = Transform::Identity,
|  | V4L2SubdeviceFormat * | sensorFormat = nullptr )

Apply a sensor configuration to the camera sensor.

Parameters

  [in] | config | The sensor configuration
  [in] | transform | The transform to be applied on the sensor. Defaults to Identity
  [out] | sensorFormat | Format applied to the sensor (optional)

Apply to the camera sensor the configuration config.

Todo
  The configuration shall be fully populated and if any of the fields specified cannot be applied exactly, an error code is returned.

Returns
  0 if config is applied correctly to the camera sensor, a negative error code otherwise

## ◆ bayerOrder()

BayerFormat::Order libcamera::CameraSensor::bayerOrder | ( | Transform | t | ) | const

Compute the Bayer order that results from the given Transform.

Parameters

  [in] | t | The Transform to apply to the sensor

Some sensors change their Bayer order when they are h-flipped or v-flipped. This function computes and returns the Bayer order that would result from the given transform applied to the sensor.

This function is valid only when the sensor produces raw Bayer formats.

Returns
  The Bayer order produced by the sensor when the Transform is applied

## ◆ computeTransform()

Transform libcamera::CameraSensor::computeTransform | ( | Orientation * | orientation | ) | const

Compute the Transform that gives the requested orientation.

Parameters

  [in,out] | orientation | The desired image orientation

This function computes the Transform that the pipeline handler should apply to the CameraSensor to obtain the requested orientation.

The intended caller of this function is the validate() implementation of pipeline handlers, that pass in the application requested CameraConfiguration::orientation and obtain a Transform to apply to the camera sensor, likely at configure() time.

If the requested orientation cannot be obtained, the orientation parameter is adjusted to report the current image orientation and Transform::Identity is returned.

If the requested orientation can be obtained, the function computes a Transform and does not adjust orientation.

Pipeline handlers are expected to verify if orientation has been adjusted by this function and set the CameraConfiguration::status to Adjusted accordingly.

Returns
  A Transform instance that applied to the CameraSensor produces images with orientation

## ◆ controls()

const ControlInfoMap & libcamera::CameraSensor::controls | ( |  | ) | const

Retrieve the supported V4L2 controls and their information.

Control information is updated automatically to reflect the current sensor configuration when the setFormat() function is called, without invalidating any iterator on the ControlInfoMap.

Returns
  A map of the V4L2 controls supported by the sensor

## ◆ device()

V4L2Subdevice * libcamera::CameraSensor::device | ( |  | ) |
| inline

Retrieve the camera sensor device.

Todo
  Remove this function by integrating DelayedControl with CameraSensor

Returns
  The camera sensor device

## ◆ entity()

const MediaEntity * libcamera::CameraSensor::entity | ( |  | ) | const
| inline

Retrieve the sensor media entity.

Returns
  The sensor media entity

## ◆ focusLens()

CameraLens * libcamera::CameraSensor::focusLens | ( |  | ) |
| inline

Retrieve the focus lens controller.

Returns
  The focus lens controller. nullptr if no focus lens controller is connected to the sensor

## ◆ getControls()

ControlList libcamera::CameraSensor::getControls | ( | const std::vector< uint32_t > & | ids | ) |

Read V4L2 controls from the sensor.

Parameters

  [in] | ids | The list of controls to read, specified by their ID

This function reads the value of all controls contained in ids, and returns their values as a ControlList. The control identifiers are defined by the V4L2 specification (V4L2_CID_*).

If any control in ids is not supported by the device, is disabled (i.e. has the V4L2_CTRL_FLAG_DISABLED flag set), or if any other error occurs during validation of the requested controls, no control is read and this function returns an empty control list.

See also
  V4L2Device::getControls()

Returns
  The control values in a ControlList on success, or an empty list on error

## ◆ getFormat()

V4L2SubdeviceFormat libcamera::CameraSensor::getFormat | ( | const std::vector< unsigned int > & | mbusCodes,
|  | const Size & | size ) const

Retrieve the best sensor format for a desired output.

Parameters

  [in] | mbusCodes | The list of acceptable media bus codes
  [in] | size | The desired size

Media bus codes are selected from mbusCodes, which lists all acceptable codes in decreasing order of preference. Media bus codes supported by the sensor but not listed in mbusCodes are ignored. If none of the desired codes is supported, it returns an error.

size indicates the desired size at the output of the sensor. This function selects the best media bus code and size supported by the sensor according to the following criteria.

- The desired size shall fit in the sensor output size to avoid the need to up-scale.
- The sensor output size shall match the desired aspect ratio to avoid the need to crop the field of view.
- The sensor output size shall be as small as possible to lower the required bandwidth.
- The desired size shall be supported by one of the media bus code listed in mbusCodes.

When multiple media bus codes can produce the same size, the code at the lowest position in mbusCodes is selected.

The use of this function is optional, as the above criteria may not match the needs of all pipeline handlers. Pipeline handlers may implement custom sensor format selection when needed.

The returned sensor output format is guaranteed to be acceptable by the setFormat() function without any modification.

Returns
  The best sensor output format matching the desired media bus codes and size on success, or an empty format otherwise.

## ◆ id()

const std::string & libcamera::CameraSensor::id | ( |  | ) | const
| inline

Retrieve the sensor ID.

The sensor ID is a free-form string that uniquely identifies the sensor in the system. The ID satisfies the requirements to be used as a camera ID.

Returns
  The sensor ID

## ◆ init()

int libcamera::CameraSensor::init | ( |  | ) |

Initialize the camera sensor instance.

This function performs the initialisation steps of the CameraSensor that may fail. It shall be called once and only once after constructing the instance.

Returns
  0 on success or a negative error code otherwise

## ◆ logPrefix()

std::string libcamera::CameraSensor::logPrefix | ( |  | ) | const
| overrideprotectedvirtual

Retrieve a string to be prefixed to the log message.

This function allows classes inheriting from the Loggable class to extend the logger with an object-specific prefix output right before the log message contents.

Returns
  A string to be prefixed to the log message

Implements libcamera::Loggable.

## ◆ mbusCodes()

const std::vector< unsigned int > & libcamera::CameraSensor::mbusCodes | ( |  | ) | const
| inline

Retrieve the media bus codes supported by the camera sensor.

Any Bayer formats are listed using the sensor's native Bayer order, that is, with the effect of V4L2_CID_HFLIP and V4L2_CID_VFLIP undone (where these controls exist).

Returns
  The supported media bus codes sorted in increasing order

## ◆ model()

const std::string & libcamera::CameraSensor::model | ( |  | ) | const
| inline

Retrieve the sensor model name.

The sensor model name is a free-formed string that uniquely identifies the sensor model.

Returns
  The sensor model name

## ◆ properties()

const ControlList & libcamera::CameraSensor::properties | ( |  | ) | const
| inline

Retrieve the camera sensor properties.

Returns
  The list of camera sensor properties

## ◆ resolution()

Size libcamera::CameraSensor::resolution | ( |  | ) | const

Retrieve the camera sensor resolution.

The camera sensor resolution is the active pixel area size, clamped to the maximum frame size the sensor can produce if it is smaller than the active pixel area.

Todo
  Consider if it desirable to distinguish between the maximum resolution the sensor can produce (also including upscaled ones) and the actual pixel array size by splitting this function in two.

Returns
  The camera sensor resolution in pixels

## ◆ sensorInfo()

int libcamera::CameraSensor::sensorInfo | ( | IPACameraSensorInfo * | info | ) | const

Assemble and return the camera sensor info.

Parameters

  [out] | info | The camera sensor info

This function fills info with information that describes the camera sensor and its current configuration. The information combines static data (such as the the sensor model or active pixel array size) and data specific to the current sensor configuration (such as the line length and pixel rate).

Sensor information is only available for raw sensors. When called for a YUV sensor, this function returns -EINVAL.

Returns
  0 on success, a negative error code otherwise

## ◆ setControls()

int libcamera::CameraSensor::setControls | ( | ControlList * | ctrls | ) |

Write V4L2 controls to the sensor.

Parameters

  [in] | ctrls | The list of controls to write

This function writes the value of all controls contained in ctrls, and stores the values actually applied to the device in the corresponding ctrls entry. The control identifiers are defined by the V4L2 specification (V4L2_CID_*).

If any control in ctrls is not supported by the device, is disabled (i.e. has the V4L2_CTRL_FLAG_DISABLED flag set), is read-only, or if any other error occurs during validation of the requested controls, no control is written and this function returns -EINVAL.

If an error occurs while writing the controls, the index of the first control that couldn't be written is returned. All controls below that index are written and their values are updated in ctrls, while all other controls are not written and their values are not changed.

See also
  V4L2Device::setControls()

Returns
  0 on success or an error code otherwise

Return values

  -EINVAL | One of the control is not supported or not accessible
  i | The index of the control that failed

## ◆ setFormat()

int libcamera::CameraSensor::setFormat | ( | V4L2SubdeviceFormat * | format,
|  | Transform | transform = Transform::Identity )

Set the sensor output format.

Parameters

  [in] | format | The desired sensor output format
  [in] | transform | The transform to be applied on the sensor. Defaults to Identity.

If flips are writable they are configured according to the desired Transform. Transform::Identity always corresponds to H/V flip being disabled if the controls are writable. Flips are set before the new format is applied as they can effectively change the Bayer pattern ordering.

The ranges of any controls associated with the sensor are also updated.

Returns
  0 on success or a negative error code otherwise

## ◆ setTestPatternMode()

int libcamera::CameraSensor::setTestPatternMode | ( | controls::draft::TestPatternModeEnum | mode | ) |

Set the test pattern mode for the camera sensor.

Parameters

  [in] | mode | The test pattern mode

The new mode is applied to the sensor if it differs from the active test pattern mode. Otherwise, this function is a no-op. Setting the same test pattern mode for every frame thus incurs no performance penalty.

## ◆ sizes()

std::vector< Size > libcamera::CameraSensor::sizes | ( | unsigned int | mbusCode | ) | const

Retrieve the supported frame sizes for a media bus code.

Parameters

  [in] | mbusCode | The media bus code for which sizes are requested

Returns
  The supported frame sizes for mbusCode sorted in increasing order

## ◆ testPatternModes()

const std::vector< controls::draft::TestPatternModeEnum > & libcamera::CameraSensor::testPatternModes | ( |  | ) | const
| inline

Retrieve all the supported test pattern modes of the camera sensor The test pattern mode values correspond to the controls::TestPattern control.

Returns
  The list of test pattern modes

## ◆ tryFormat()

int libcamera::CameraSensor::tryFormat | ( | V4L2SubdeviceFormat * | format | ) | const

Try the sensor output format.

Parameters

  [in] | format | The desired sensor output format

The ranges of any controls associated with the sensor are not updated.

Todo
  Add support for Transform by changing the format's Bayer ordering before calling subdev_->setFormat().

Returns
  0 on success or a negative error code otherwise

The documentation for this class was generated from the following files:

- include/libcamera/internal/camera_sensor.h
- src/libcamera/sensor/camera_sensor.cpp